module Compile

import AST;

@doc{Java code generation

There are multiple ways for generating code from a state machine. You
may consider one of the following alternatives:

- Generate a single switch statement, which dispatches on integer
  constants defined for each state. Upon transitioning, a
  current-state variable is updated.
- Generate methods for each state which call other state methods upon
  transitioning.
- Generate object instantiations according to Fowler's text.
 
Note that upon entering states the actions (if any) should be
executed. To be able to run the code, assume the input stream is a
java.util.Scanner object, and use nextLine to obtain the next
token. Actions print tokens onto an outputstream, which can be a
java.io.PrintWriter. You may want to use pattern-based dispatch
to break the compile function into smaller pieces.
}
public str compile(str className, Controller ctl) {
  return "TODO";
}
