module Extract

import AST;

@doc{Fact extraction

The first relation captures the transition structure of a state
machine: it contains tuples <s, t, s'>, where s is the source state,
t the triggering token, and s' the target state. The second relation
captures which tokens should be output upon entering a certain
state. Note that both relations use tokens and not the names of events
or actions. This means that in your extraction you should take care of
looking up event/command names to find the associated tokens. 
}
alias TransRel = rel[str state, str eventToken,  str toState];
alias ActionRel = rel[str state, str commandToken];



public TransRel transRel(Controller ctl) {
  return {};
}

public ActionRel commands(Controller ctl) {
  return {};
} 
